# -*- encoding : utf-8 -*-
class AddActualDeadlineFields < ActiveRecord::Migration
  def self.up
    rename_column :admissions, :application_deadline, :shown_application_deadline
    rename_column :admissions, :priority_deadline, :user_priority_deadline
    remove_column :admissions, :show_on_frontpage
    add_column :admissions, :shown_from, :datetime
    add_column :admissions, :admin_priority_deadline, :datetime
    add_column :admissions, :actual_application_deadline, :datetime

    Admission.reset_column_information
    Admission.find_by_sql("SELECT * FROM admissions").each do |admission|
      admission.shown_from = admission.shown_application_deadline - 2.weeks
      admission.admin_priority_deadline = admission.user_priority_deadline + 1.hours,
      admission.actual_application_deadline = admission.shown_application_deadline + 4.hours
      admission.save(validate: false)
    end
  end

  def self.down
    rename_column :admissions, :shown_application_deadline, :application_deadline
    rename_column :admissions, :user_priority_deadline, :priority_deadline
    add_column :admissions, :show_on_frontpage, :boolean
    remove_column :admissions, :shown_from
    remove_column :admissions, :admin_priority_deadline
    remove_column :admissions, :actual_application_deadline

    Admission.reset_column_information
    Admission.find_by_sql("SELECT * FROM admissions").each do |admission|
      admission.show_on_frontpage = true
      admission.save(validate: false)
    end
  end
end
